# convert a Fortran file to have lines with 72 or fewer characters.
#

sub f72 {
    local($in_file, $out_file) = @_;
    if (!-f $in_file) {
        print STDERR "$0: $in_file: no such file.\n";
        exit(-1);
    }

    $ten_spaces = "          ";

    if (!open (FIN,"<$in_file") ||(!open (FOUT,">$out_file") ))  {
        print STDERR "$0: I/O error.\n";
        exit(-1);
    }

    while(<FIN>) {
        chop;
        &hack_up($_);
    }
}

sub hack_up {
    local($line) = @_;
    if ($line =~ m/\t/) {
        $line = &t_s($line);
    }

    if (length($line) > 72) {
        $nl = substr($line,72,length($line)-72);
        $nl = "     +$nl";
        $line = substr($line,0,72);
        print FOUT "$line\n";
        &hack_up($nl);
    } else {
        print FOUT "$line\n";
    }
}

sub t_s {
    local($old_line) = @_;
    $o_len = length($old_line);
    $new_line = "";
    $co_pos = 0; $cn_pos = 0;
    while ($co_pos < $o_len) {
        if (substr($old_line,$co_pos,1) =~ /\t/) {
            $t_len = 8 - ($cn_pos%8);
            $new_line .= substr($ten_spaces,0,$t_len);
            $cn_pos += $t_len;
        } else {
            $new_line .= substr($old_line,$co_pos,1);
            $cn_pos++;
        }
        $co_pos++;
    }
    return($new_line);
}
1;

