#
# Please see the COPYRIGHT_and_DISCLAIMER file in the top level
# directory of the distribution regarding the provisions under
# which this software is distributed.
#
$| = 1;

$SourceDir = shift(@ARGV);

push(@INC, "$SourceDir");

$show_parse_errors = 0;

$load_errors = 0;

&load_file('newgetopt.pl');

$opt_d = 0;
$opt_g = 0;

&NGetOpt("d:n","dump", "trace:n", "dumpafter=s@","dump_raw", "v",
	 "common_file:s", "target:s", "g", "f2c", "allow_common");

$opt_proc = 1;

$allow_plain_common = $opt_allow_common ? 1 : 0;

print "Load path is @INC\n" if $opt_v;
print "Debug flag is '$opt_g'\n" if $opt_v;
&load_file('all.pl');

&load_file('f72.pl') if $opt_target eq 'crayc90';

exit 1 if $load_errors;

$debugLevel = $opt_trace + 0;

$commentChar = 'c';
if ($opt_target eq "rs6000" && !$opt_f2c)
{
    $commentChar = '"';
    $rs6k_xlf_target = 1;
}



&debug'setLevel($opt_d + 0);

#$SIG{'SEGV'} = 'segfaultHandler';
#$SIG{'BUS'} = 'segfaultHandler';

if (@ARGV != 3)
{
    die "Invalid command line\n";
}

($input_file, $src_file_name, $file_base) = @ARGV;

&processFile($input_file, $src_file_name, $file_base);

exit 0;

sub processFile
{
    local($file, $file_name, $FileBase) = @_;
    local($errors);

    $FileBaseNoSpecials = $FileBase;

    $FileBaseNoSpecials =~ s/[^a-zA-Z0-9_]/_/g;
    $FileBaseNoSpecials = "\L$FileBaseNoSpecials";

    $errors = 0;
    &cfutils_init;

    $fort_out = "${FileBase}.f";
    $fort_out_tmp = "${FileBase}.tmp.f";

    $c_out = "${FileBase}__.c";
    $c_out_tmp = "${FileBase}__.tmp.c";
    
    &readfile($file, $file_name);

    &performDump("read");

    &applyToPrograms("xformTypes");
    
    &performDump("types");

    if ($opt_nexus || $opt_proc)
    {
	&applyToPrograms("xformProcessors");
	&performDump("processors");
    }

    &applyToPrograms("xformPorts");

    &performDump("ports");

    &applyToPrograms("xformStatements");

    &performDump("stmts");

    &applyToPrograms("xformParallelBlocks");

    &performDump("parblocks");

    if (!open(WRAP, ">$c_out_tmp"))
    {
	die "Cannot open $c_out_tmp: $!\n";
    }

    &genWrapperHeader(WRAP);
    
    @FM_Handlers = ();

    &applyToPrograms("genSpawnCode", WRAP);

    &genSRWrappers(WRAP);

    if ($opt_nexus || $opt_proc)
    {
	&generateHandlerTable(WRAP);
    }
    
    if (!open(OUT, ">$fort_out_tmp"))
    {
	die "Cannot open $fort_out_tmp: $!\n";
    }
    &writeFortran(OUT);
    close(OUT);
    &dump if $opt_dump;
    
    print "$errors errors encountered for $file_name\n"
	if $opt_v || $errors > 0;
    if ($errors == 0)
    {
	#
	# If we're on a Cray, don't rename. Run the 72-character
	# line splitter instead.
	#
	if ($opt_target eq 'crayc90')
	{
	    &f72($fort_out_tmp, $fort_out);
	}
	else
	{
	    if (!rename($fort_out_tmp, $fort_out))
	    {
		&warning("Couldn't rename $fort_out_tmp to $fort_out: $!");
	    }
	}
	if (!rename($c_out_tmp, $c_out))
	{
	    &warning("Couldn't rename $c_out_tmp to $c_out: $!");
	}
    }
    elsif ($opt_v)
    {
	warn "Compile errors in $file_name, leaving output in $fort_out_tmp and $c_out_tmp\n";
	warn "Dumping state to cfcore\n";
	
	open(STDOUT, ">cfcore");
	&dump;
	exit 1;
    }
    else
    {
        exit 1;
    }
}

sub segfaultHandler
{
    &fatal("AAAAUUUUUUGGGGGHHHHHHHH");
}

sub performDump
{
    local($when) = @_;

    if (grep($_ =~ /$when/i, @opt_dumpafter))
    {
	&dump;
    }
}

sub load_file
{
    local($file) = @_;

#    print "Loading $file\n";

    if (!do $file)
    {
	warn "Could not load file $file:\n$@\n";
	warn "Include path is ", join(":", @INC), "\n";
	$load_errors++;
    }
}

