/*
 * Please see the COPYRIGHT_and_DISCLAIMER file in the top level
 * directory of the distribution regarding the provisions under
 * which this software is distributed.
 */


#undef TYPE_DEF

#define TYPE_DEF(name, string) name,
enum node_type
{
#include "types.def"
    LAST_TYPE
};

#undef TYPE_DEF
#define TYPE_DEF(name, string) string,
static char *tree_type_names[] = {
#include "types.def"
    (char *) 0
    };

    
#define PT_DECLARATION	1
#define PT_EXECUTABLE	2
#define PT_SUBPROGRAM	3
#define PT_INCLUDE	4

enum control_specifier_type
{
    CTL_SPEC_IN = 1,
    CTL_SPEC_OUT,
    CTL_SPEC_IOSTAT,
    CTL_SPEC_ERR,
    CTL_SPEC_FROM,
    CTL_SPEC_TO,
    CTL_SPEC_PORT,
    CTL_SPEC_END,
    CTL_SPEC_EMPTY,
    CTL_SPEC_LAST
};

#define N_CTL_SPECS 11

static char *control_specifier_type_names[] =
{
    "",
    "in",
    "out",
    "iostat",
    "err",
    "from",
    "to",
    "port",
    "end",
    "empty",
    (char *)0
};

struct primitive_arg_type
{
    enum node_type type;
    enum control_specifier_type defaults[N_CTL_SPECS];
    enum control_specifier_type valid[N_CTL_SPECS];
};

static struct primitive_arg_type arg_types_for_primitive[] =
{
    { TREE_CHANNEL,
      { CTL_SPEC_OUT, CTL_SPEC_IN, CTL_SPEC_LAST },
      { CTL_SPEC_IOSTAT, CTL_SPEC_ERR, CTL_SPEC_LAST }
    },
    { TREE_MERGER,
      { CTL_SPEC_OUT, CTL_SPEC_IN, CTL_SPEC_LAST },
      { CTL_SPEC_IOSTAT, CTL_SPEC_ERR, CTL_SPEC_LAST }
    },
    { TREE_MOVE_PORT,
      { CTL_SPEC_FROM, CTL_SPEC_TO, CTL_SPEC_LAST },
      { CTL_SPEC_IOSTAT, CTL_SPEC_ERR, CTL_SPEC_LAST }
    },
    { TREE_SEND,
      { CTL_SPEC_PORT, CTL_SPEC_LAST },
      { CTL_SPEC_IOSTAT, CTL_SPEC_ERR, CTL_SPEC_LAST }
    },
    { TREE_CHANNEL_CLOSE,
      { CTL_SPEC_PORT, CTL_SPEC_LAST },
      { CTL_SPEC_IOSTAT, CTL_SPEC_ERR, CTL_SPEC_LAST }
    },
    { TREE_RECV,
      { CTL_SPEC_PORT, CTL_SPEC_LAST },
      { CTL_SPEC_IOSTAT, CTL_SPEC_ERR, CTL_SPEC_END, CTL_SPEC_LAST }
    },
    { TREE_PROBE,
      { CTL_SPEC_PORT, CTL_SPEC_LAST },
      { CTL_SPEC_IOSTAT, CTL_SPEC_ERR, CTL_SPEC_EMPTY, CTL_SPEC_LAST }
    },
    { -1 }
};
	  
    
