/*
 * Please see the COPYRIGHT_and_DISCLAIMER file in the top level
 * directory of the distribution regarding the provisions under
 * which this software is distributed.
 */

#ifndef _YOKE_TYPES_H
#define _YOKE_TYPES_H


/*
 * YOKE_PROTO_DATA_UNION is #define'd in config.h
 */
typedef union _proto_data_union_t
{
    proto_type_t type;
    YOKE_PROTO_DATA_UNION
} proto_data_union_t;


/*
 * A yoke_proto_t must start with a "yoke_proto_funcs_t funcs" as
 * its first element.  This is so that typecasts using yoke_basic_proto_t
 * can be done in yoke.h, without needing to export the icky
 * proto_data_union_t which relies on config.h.
 */
struct _yoke_proto_t
{
    yoke_proto_funcs_t funcs;
    proto_data_union_t data;
    struct _yoke_proto_t *next;
};


/*
 * yoke_basic_buffer_t is defined in yoke.h.  It is needed there
 * in order to do typecasts for yoke_buffer_t, without needing
 * to export this icky union which relies on config.h.
 *
 * YOKE_BUFFER_UNION is #define'd in config.h
 */
union _yoke_buffer_t
{
    struct _yoke_basic_buffer_t basic;
    YOKE_BUFFER_UNION
};

#endif /* _YOKE_TYPES_H */
